Bug 165060

Summary: nfs-utils init scripts fail on kernels with built-in NFS
Product: [Fedora] Fedora Reporter: Nicholas Miell <nmiell>
Component: nfs-utilsAssignee: Steve Dickson <steved>
Status: CLOSED RAWHIDE QA Contact: Ben Levenson <benl>
Severity: medium Docs Contact:
Priority: medium    
Version: 6CC: mrb
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2008-02-26 09:35:10 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description Nicholas Miell 2005-08-03 19:33:26 EDT
The init scripts for rpcgssd, rpcidmapd and rcpscvsgssd all fail to function on
kernels with built-in NFS. (The scripts check lsmod output for specific modules
and then try to load them if not found, which obviously won't work if they're
statically linked into the kernel.)

I don't personally care about this issue, but it makes Zwane Mwaikambo sad.
Comment 1 Michael Belanger 2005-08-29 13:27:49 EDT
I am also seeing this with 2.6.12-1.1398_FC4smp on x86_64.

At first I thought this might be a bug with firing order.. but perhaps not. 
Restarting NFS after the system is booted seems to start NFS okay.. but this
isn't a good solution.
Comment 2 Steve Dickson 2005-09-01 08:06:31 EDT
Its not clear to me that this is a bug, since the default configuration
of FC4 is to have NFS (and friends) as modules. Basically your changing
the default configuration which is breaking the NFS init script...
True or am I missing something??? 
Comment 3 Michael Belanger 2005-09-01 10:52:15 EDT
Kernel Modules?

Well.. I am doing the same thing I did with FC2 and FC3 for sharing filesystems.
 I add the filesystems to /etc/exports and turn on the nfsd services.

2 things I am seeing -- which could very well be a lack of understanding on the
new way of doing things with Fedora.  1.  exportfs is useless.  2. Though I
haven't seen this behavior since installing 2.6.12-1.1447_FC4smp kernel
(x86_64), NFS - or parts of its services were failing on boot.

Am I, others, approaching kernel-based NFS incorrectly? or was this issue
actually resolved in the new kernel?
Comment 4 Steve Dickson 2005-09-01 14:06:58 EDT
So just to be clear, neither of you are recompiling the kernel
and changing NFS, SUNRPC, etc to be "statically linked into
the kernel" ? If this is the case then the init scripts should
not be failing...

Comment 5 Nicholas Miell 2005-09-01 16:28:26 EDT
No, nfs and the related modules are built-in to the kernel, and the NFS scripts
are failing because they can't find the modules (which, obviously, don't exist). 
If you just remove the checks for the non-existent modules, everything works
fine (well, until you switch to a kernel with modular NFS, in which case the
scripts fail to load the modules).

Every other init script which depends on kernel functionality is written to deal
with modular or monolithic kernels, regardless of what Red Hat actually ships. 
Typically, they check for something in /proc to determine if the kernel support
is there and then fall back to attempting to load the modules before giving up.
(i.e. instead of checking the output of lsmod for sunrpc, check the contents of
/proc/filesystems for rpc_pipefs and then modprobe sunrpc if it isn't found)

You could argue that supporting non-Red Hat kernels isn't required, but that's a
lousy way to encourage kernel developers (like Zwane) to use Fedora/RHEL.
Comment 6 Steve Dickson 2005-09-01 20:16:03 EDT
Fine... now I understand and I do agree with you wrt encouraging developers
to use FC.... Let me look into this... 
Comment 7 Steve Dickson 2005-09-01 20:18:16 EDT
Adding this bug to FC5 Target Tracker bug list... 
Comment 8 Christian Iseli 2007-01-22 05:10:49 EST
This report targets the FC3 or FC4 products, which have now been EOL'd.

Could you please check that it still applies to a current Fedora release, and
either update the target product or close it ?

Thanks.
Comment 9 Nicholas Miell 2007-01-22 23:02:40 EST
Still broken in FC6, assuming you care about supporting people who build their
own kernels with statically linked NFS modules.
Comment 10 petrosyan 2008-02-25 19:04:56 EST
Nicholas, Fedora Core 6 is not maintained anymore. Is this bug still present in
Fedora 8?
Comment 11 Nicholas Miell 2008-02-25 19:32:41 EST
Looks like the init scripts check for rpc_pipefs in /proc/mounts before
attempting module loading, so I'd say it is fixed.
Comment 12 Steve Dickson 2008-02-26 09:35:10 EST
Yes, setting RPCMTAB=noload will stop the check for the needed modules.